{$apptype console}

uses
  Types, SysUtils, Math;

var
  n, p, m, mp, mnp: integer;
  c: TBooleanDynArray;
  d: array of TBooleanDynArray;

procedure GenEdges(Cnt: integer; P1, P2: boolean; var E1, E2: TIntegerDynArray);
var
  i, t1, t2: integer;
  l: integer;
begin
  l := Length(E1);
  SetLength(E1, l + Cnt);
  SetLength(E2, l + Cnt);
  for i := 1 to Cnt do begin
    repeat
      t1 := Random(n);
      t2 := Random(n);
    until
      (t1 <> t2) and (c[t1] = p1) and (c[t2] = p2) and
      (not d[t1, t2]) and not (d[t2, t1]);
    d[t1, t2] := true;
    E1[l + i - 1] := t1 + 1;
    E2[l + i - 1] := t2 + 1;
  end;
end;

var
  i, t: integer;
  e1, e2: TIntegerDynArray;
begin
  RandSeed := StrToInt(ParamStr(1));
  n := StrToInt(ParamStr(2));
  m := StrToInt(ParamStr(3));   // >= mp + mnp, m - mp - mnp <= p * (n - p) / 2
  p := StrToInt(ParamStr(4));   // must be <= n
  mp := StrToInt(ParamStr(5));  // additional edges -- producers -- max p * (p - 1) / 2
  mnp := StrToInt(ParamStr(6)); // additional edges -- non-producers -- max (n - p) * (n - p - 1) / 2

  p := Min(p, n);
  mnp := Min(mnp, (n - p) * (n - p - 1) div 2);
  mp := Min(mp, p * (p - 1) div 2);
  m := Max(m, mp + mnp);
  m := mp + mnp + Min(m - mp - mnp, p * (n - p) div 2);

  SetLength(c, n);
  FillChar(c[0], n, false);
  SetLength(d, n, n);
  for i := 0 to n - 1 do
    FillChar(d[i][0], n, false);

  for i := 1 to p do begin
    repeat
      t := Random(n);
    until (not c[t]);
    c[t] := true;
  end;

  e1 := nil;
  e2 := nil;
  GenEdges(mp, true, true, e1, e2);
  GenEdges(mnp, false, false, e1, e2);
  GenEdges(m - mp - mnp, true, false, e1, e2);

  Writeln(n, ' ', m);
  for i := 0 to High(e1) do
    Writeln(e1[i], ' ', e2[i]);
end.
